#!/usr/bin/perl

%sse_insns = (
	"mov", "movdqa",
	"and", "pand",
	"or", "por",
	"xor", "pxor",
	"andn", "pandn",
	"not", "pxor"
);

sub process_sbox
{
	my $i, $j, $k, $vregs, $v1, $v2, $x, $r, $m;

	undef %depcounts;
	undef %deps;
	undef %var2vreg;
	undef @vreg;
	undef @vsrc;
	undef @vdstmov;
	undef @vdstop;
	undef @vw;
	undef @vreg2reg;
	undef @vreg2mem;
	undef @vreg2r;

	print "insn: ", $n, "\n";

	for ($i = 0; $i < $n; $i++) {
		$k = $depcounts{$r1[$i]}++;
		$deps{$r1[$i]}[$k] = $i;
		if ($r1[$i] ne $r2[$i]) {
			$k = $depcounts{$r2[$i]}++;
			$deps{$r2[$i]}[$k] = $i;
		}
	}

	for ($k = 0; $k < 6; $k++) {
		$var2vreg{"a" . ($k + 1)} = $k;
		$vreg[$k] = 1; # in use
	}
	for ($k = 0; $k < 4; $k++) {
		$var2vreg{"*out" . ($k + 1)} = 1001 + $k;
	}

	for ($i = $j = 0; $i < $n; $i++) {
		$vinsn[$j] = $insn[$i];
		$vr1[$j] = $var2vreg{$r1[$i]};
		$vr2[$j] = $var2vreg{$r2[$i]};
		$k = $depcounts{$r1[$i]};
		if ($deps{$r1[$i]}[$k - 1] == $i) {
			undef $var2vreg{$r1[$i]};
			$vreg[$vr1[$j]] = 0;
		}
		$k = $depcounts{$r2[$i]};
		if ($deps{$r2[$i]}[$k - 1] == $i) {
			undef $var2vreg{$r2[$i]};
			$vreg[$vr2[$j]] = 0;
		}
		$k = $var2vreg{$r3[$i]};
		$vreg[$k] = 0 if (defined $k);
		$k = $vr2[$j];
#		$k = $vr1[$j] if (!$vreg[$vr1[$j]] && $vr1[$j] < $k && $vinsn[$j] ne "andn");
		$k = $vr1[$j] if (!$vreg[$vr1[$j]] && $vdstop[$vr1[$j]] > $vdstop[$k] && $vinsn[$j] ne "andn");
		$k = $vr1[$j] if ($vreg[$k] || $k > 1000);
		if ($vreg[$k] || $k > 1000) {
			$k = 0; $k++ while ($vreg[$k]);
		}
		$var2vreg{$r3[$i]} = $k;
		$vreg[$k] = 1;
		($vr1[$j], $vr2[$j]) = ($vr2[$j], $vr1[$j])
			if ($vr1[$j] == $k && $vinsn[$j] ne "andn");
		if ($vr2[$j] != $k) {
			if ($vr1[$j] == $k) { # andn a,b,a
				$k = 0; $k++ while ($vreg[$k]);
				$var2vreg{$r3[$i]} = $k;
				$vreg[$k] = 1;
				undef $var2vreg{$r1[$i]};
				$vreg[$vr1[$j]] = 0;
			}
			$vinsn[$j + 1] = $vinsn[$j];
			$vr1[$j + 1] = $vr1[$j];
			$vr2[$j + 1] = $k;
			$vinsn[$j] = "mov";
			$vr1[$j] = $vr2[$j];
			$vr2[$j] = $k;
			$j++;
		}
		if ($vr1[$j] > 1000) {
			$vr2[$j + 1] = $vr1[$j];
			$vr1[++$j] = $k;
			$vinsn[$j] = "mov";
		}
		$j++;

		# hack
		$vregs = 0;
		undef @vsrc;
		undef @vdstmov;
		undef @vdstop;
		for ($k = 0; $k < $j; $k++) {
			$v1 = $vr1[$k];
			$v2 = $vr2[$k];
			$vregs = $v1 + 1 if ($v1 >= $vregs && $v1 < 1000);
			$vregs = $v2 + 1 if ($v2 >= $vregs && $v2 < 1000);
			$vsrc[$v1]++ if ($vinsn[$k] ne "not");
			if ($vinsn[$k] eq "mov") {
				$vdstmov[$v2]++;
			} else {
				$vdstop[$v2]++;
			}
		}
	}

	print "vinsn: ", $j, "\n";

	my $w;
	for ($k = 0; $k < $vregs; $k++) {
#		$vw[$k] = $vsrc[$k] + $vdstmov[$k] * 10 + $vdstop[$k] * 10000 +
#			(($k < 6) ? 50 : 0);
		$w = $vsrc[$k] + $vdstmov[$k];
		$w += 10000 + $vdstop[$k] if ($vdstop[$k]);
		$vw[$k] = $w;
	}

	for ($r = 0; $r < 16; $r++) {
		$worst = -1;
		$worstw = -1;
		for ($k = 0; $k < $vregs; $k++) {
			$kw = $vw[$k];
			$kw += 1000 if ($k == $r && $r < 6);
			if ($kw > $worstw && !defined($vreg2reg[$k])) {
				$worst = $k;
				$worstw = $kw;
			}
		}
		$vreg2reg[$worst] = $r if ($worst >= 0);
	}

	for ($v1 = 0; $v1 < 6; $v1++) {
		for ($v2 = 0; $v2 < $vregs; $v2++) {
			if ($v1 != $v2 &&
			    defined($vreg2reg[$v1]) &&
			    defined($vreg2reg[$v2]) && $vreg2reg[$v2] == $v1) {
				($vreg2reg[$v1], $vreg2reg[$v2]) =
					($vreg2reg[$v2], $vreg2reg[$v1]);
				last;
			}
		}
	}

	$m = 0;
	for ($k = 0; $k < $vregs; $k++) {
		$vreg2mem[$k] = $m++ if (!defined($vreg2reg[$k]));
	}

	print "vregs: $vregs\n";
	for ($k = 0; $k < $vregs; $k++) {
		print $k, ": ",
			$vsrc[$k], "+", $vdstmov[$k], "+", $vdstop[$k],
			" => ", $vw[$k],
			" (", defined($vreg2reg[$k])
				? "r" . $vreg2reg[$k]
				: "m" . $vreg2mem[$k], ")",
			"\n";
	}

	for ($k = 0; $k < $vregs; $k++) {
		if (defined($vreg2reg[$k])) {
			$vreg2r[$k] = "%xmm" . $vreg2reg[$k];
		} else {
			$vreg2r[$k] = "tmp_at(" . ($vreg2mem[$k] + 1) . ")";
		}
	}
	for ($k = 0; $k < 4; $k++) {
		$vreg2r[1001 + $k] = "out" . ($k + 1);
	}

	$k = 0;
	for ($v1 = 0; $v1 < 6; $v1++) {
		if (defined($vreg2mem[$v1])) {
			$rinsn[$k] = $sse_insns{"mov"};
			$rr1[$k] = "%xmm" . $v1;
			$rr2[$k] = $vreg2r[$v1];
			$k++;
		}
	}
	for ($i = 0; $i < $j; $i++) {
		$rinsn[$k] = $sse_insns{$vinsn[$i]};
		$rr1[$k] = $vreg2r[$vr1[$i]];
		$rr1[$k] = "pnot" if ($vinsn[$i] eq "not");
		$rr2[$k] = $vreg2r[$vr2[$i]];
		$k++;
	}

	print "rinsn: ", $k, "\n";
#	for ($i = 0; $i < $k; $i++) {
#		print $rinsn[$i], " ", $rr1[$i], ",", $rr2[$i], "\n";
#	}
#
#	print "\nscheduled:\n";

	undef %retiring;
	my $best, $bestw, $w1, $w2, $w, $latency, $alu;

	$alu = 0;
	for ($i = 0; $i < $k; $i++) {
		$best = -1;
		$bestw = -1000;
		undef %ins;
		undef %outs;
		for ($j = 0; $j < $k; $j++) {
			next if (!defined($rinsn[$j]));
			if (!$outs{$rr1[$j]} && !$outs{$rr2[$j]} &&
			    !$ins{$rr2[$j]}) {
				if (!defined($retiring{$rr1[$j]}) &&
				    !defined($retiring{$rr2[$j]})) {
					$best = $j; last;
				}
				$w1 = $i - $retiring{$rr1[$j]};
				$w2 = $i - $retiring{$rr2[$j]};
				$w = ($w1 < $w2) ? $w1 : $w2;
				if ($rinsn[$j] !~ /mov/) {
					$w = $i - $alu if ($w > $i - $alu);
				}
				if ($w > $bestw) {
					$best = $j; $bestw = $w;
				}
				last if ($bestw >= 0);
			}
			$ins{$rr1[$j]}++;
			$ins{$rr2[$j]}++;
			$outs{$rr2[$j]}++;
		}
		$j = $best;
		if ($rinsn[$j] =~ /mov/) {
			$latency = 6;
			$alu = $i;
		} else {
			$latency = 2;
			$alu = $i + 2;
		}
		$retiring{$rr2[$j]} = $i + $latency;
#		print $rinsn[$j], " ", $rr1[$j], ",", $rr2[$j], "\n";
		print "\t", $rinsn[$j], " ", $rr1[$j], ",", $rr2[$j];
		print "; \\" if ($i < $k - 1);
		print "\n";
		undef $rinsn[$j];
	}

	print "\n";
}

%ops = ("&", "and", "|", "or", "^", "xor", "~", "not");

$n = 0;
while (<>) {
	s/\r$//;
	$n = 0 if (/{/);
	process_sbox() if (/}/);
	($r, $a, $op, $not, $b) =
		/^\t*(\**[\w\d]+) *= *(\**[\w\d]+) *([&|^]) *([(~]*)(\**[\w\d]+)[);];*$/;
	if (!$r) {
		($r, $not, $b, $op, $a) =
			/^\t*([\w\d]+) *= *([(~]*)([\w\d]+)[) ] *([&|^]) *([\w\d]+);$/;
	}
	if (!$r) {
		($r, $op, $b) = /^\t*([\w\d]+) *= *(~)([\w\d]+);$/;
		$a = $b;
		undef $not;
	}
	if (!$r) {
		($a, $op, $b) = /^\t*(\*[\w\d]+) *(\^)= *([\w\d]+);$/;
		$r = $a;
		undef $not;
	}
	if (!$r) {
		print STDERR "Could not parse: $_" if (/=/);
		next;
	}
	$op = $ops{$op};
	if ($not && $op eq "and") {
		$op = "andn";
	} elsif ($not && $op eq "xor") {
		$insn[$n] = $op;
		$r1[$n] = $a;
		$r2[$n] = $b;
		$r3[$n++] = $r;
		$insn[$n] = "not";
		$r1[$n] = $r;
		$r2[$n] = $r;
		$r3[$n++] = $r;
		next;
	} elsif ($not) {
		die;
	}
	if ($r && $a && $op && $b) {
		$insn[$n] = $op;
		$r1[$n] = $a;
		$r2[$n] = $b;
		$r3[$n++] = $r;
		next;
	}
}
